//+------------------------------------------------------------------+
//|                                                    TickPulse.mq4 |
//|                                                           Dagnar |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dagnar"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 DarkTurquoise
//---- input parameters
extern int       MAper=10;
extern int       hst=200;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ma_buf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ma_buf);
   for (int i=0; i<hst; i++) {
   ExtMapBuffer1[i]=Close[0];
   ExtMapBuffer2[i]=Close[0];
   ExtMapBuffer3[i]=Close[0];
   ma_buf[i]=Close[0];
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
double WMA(int x, int p)
  {
   return(iMAOnArray(ExtMapBuffer3, 0, p, 0, 3, x));
  }
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int i,j;
  
   for (i=hst; i>0; i--) {
    ExtMapBuffer1[i]=ExtMapBuffer1[i-1];
    ExtMapBuffer2[i]=ExtMapBuffer2[i-1];
    ExtMapBuffer3[i]=ExtMapBuffer3[i-1];
    ma_buf[i]=ma_buf[i-1];
   }
   double ma=0,c=0;
   double vect[];
   ArrayResize(vect, hst);
   ArraySetAsSeries(vect, true);  
   for(int x=0; x < hst; x++)
     {
      vect[x]=2*WMA(x, MAper/2) - WMA(x, MAper);
      }
   ExtMapBuffer3[0]=Close[0];
   int p=MathSqrt(MAper);
   ma_buf[0]=iMAOnArray(vect, 0, p, 0, 3, 0);
   double m1=0,m2=0,c1=0,c2=0;
    for (j=0; j<5; j++) {  
     if (ExtMapBuffer3[j]!=EMPTY_VALUE) {m1=m1+ExtMapBuffer3[j];c1++;}
     if (ExtMapBuffer3[j+1]!=EMPTY_VALUE) {m2=m2+ExtMapBuffer3[j+1];c2++;}
    }
    m1=m1/c1; m2=m2/c2;
   if (ma_buf[1]!=0 && ma_buf[1]!=EMPTY_VALUE) {
     if (ma_buf[0]>=ma_buf[1]) {ExtMapBuffer1[0]=m1;  ExtMapBuffer2[0]=EMPTY_VALUE;
       if (ma_buf[1]<ma_buf[2]) {ExtMapBuffer1[1]=m2;}
       }
     if (ma_buf[0]<ma_buf[1]) {ExtMapBuffer2[0]=m1;  ExtMapBuffer1[0]=EMPTY_VALUE;
       if (ma_buf[1]>=ma_buf[2]) {ExtMapBuffer2[1]=m2; }
     }     
   }
 
//----
   return(0);
  }
//+------------------------------------------------------------------+